SystemOrganization addCategory: #FastDetector!

Object subclass: #FastDetector
	instanceVariableNames: 'keyGenerator collection dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastDetector'!

!FastDetector methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/21/2013 10:13'!
add: anObject
	collection add: anObject.
	self addOnlyToDictionary: anObject.! !

!FastDetector methodsFor: 'private' stamp: 'HwaJong 7/21/2013 10:12'!
addOnlyToDictionary: anObject

	self dictionary at: (keyGenerator value: anObject) put: anObject! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:15'!
at: anObject
	^self dictionary at: anObject! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/24/2013 10:08'!
collection
	^ collection! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 18:53'!
collection: anInterval 
	collection := anInterval! !

!FastDetector methodsFor: 'defaults' stamp: 'HwaJong 7/21/2013 10:14'!
defaultDictionary
	|dic|
	dic := Dictionary new.
	collection do: [:each| dic at: (keyGenerator value: each) put: each].
	^dic! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 18:55'!
dictionary
	^ dictionary setDefault: #defaultDictionary for: self withSetter: #dictionary:! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 18:56'!
dictionary: aDictionary 
	dictionary := aDictionary! !

!FastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 18:54'!
keyGenerator: aBlockClosure 
	keyGenerator := aBlockClosure! !

!FastDetector methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/20/2013 19:13'!
updateDictionary
	self dictionary: self defaultDictionary.! !

Object subclass: #MFDTestDummyItem
	instanceVariableNames: 'name id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastDetector'!

!MFDTestDummyItem methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:08'!
id
	^ id! !

!MFDTestDummyItem methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:08'!
id: anObject
	id := anObject! !

!MFDTestDummyItem methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:08'!
name
	^ name! !

!MFDTestDummyItem methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:08'!
name: anObject
	name := anObject! !

Object subclass: #MultiFastDetector
	instanceVariableNames: 'collection detectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastDetector'!

!MultiFastDetector methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/21/2013 10:11'!
add: anObject
	collection add: anObject.
	detectors do: [:each| each addOnlyToDictionary: anObject ].! !

!MultiFastDetector methodsFor: 'testing' stamp: 'HwaJong 7/21/2013 10:20'!
areDetectorsSharingCollectionCorrectly

	^detectors allSatisfy: [:each| each collection == collection ]! !

!MultiFastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:38'!
collection
	^ collection! !

!MultiFastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/20/2013 19:37'!
collection: anOrderedCollection 
	collection := anOrderedCollection! !

!MultiFastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/24/2013 10:18'!
detect: aSymbol equals: anObject 
	^(self detectorAt: aSymbol) at: anObject! !

!MultiFastDetector methodsFor: 'accessing' stamp: 'HwaJong 7/24/2013 09:50'!
detectorAt: aSymbol 
	^detectors at: aSymbol ifAbsentPut: 
		[
			FastDetector new
				collection: collection;
				keyGenerator: [:value| value perform: aSymbol ]
		]! !

!MultiFastDetector methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/20/2013 19:39'!
initialize 
	super initialize.
	detectors := Dictionary new.! !

!MultiFastDetector methodsFor: 'testing' stamp: 'HwaJong 7/21/2013 10:21'!
isSane

	^self areDetectorsSharingCollectionCorrectly! !

TestCase subclass: #FastDetectorTest
	instanceVariableNames: 'col item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastDetector'!

!FastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:49'!
setUp
	super setUp.
	col := OrderedCollection new.
	item := MFDTestDummyItem new id: 'AB'; name: 'Darin'.! !

!FastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:16'!
testIdDetector

| idDetector |
idDetector := FastDetector new.

idDetector collection: col.
idDetector keyGenerator: [:value| value id ].
self assert: idDetector dictionary equals: (Dictionary newFrom: {}).

col add: item.

idDetector updateDictionary.
self assert: idDetector dictionary equals: (Dictionary newFrom: {'AB' -> item}).

self assert: (idDetector at:  'AB') == item.! !

!FastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:14'!
testNameDetector

| nameDetector |
nameDetector := FastDetector new.

nameDetector collection: col.
nameDetector keyGenerator: [:value| value name ].
self assert: nameDetector dictionary equals: (Dictionary newFrom: {}).

col add: item.

nameDetector updateDictionary.
self assert: nameDetector dictionary equals: (Dictionary newFrom: {'Darin' -> item}).

self assert: (nameDetector at: 'Darin') == item.
! !

!FastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:14'!
testTwoDetector

| idDetector nameDetector |
idDetector := FastDetector new.
idDetector collection: col.
idDetector keyGenerator: [:value| value id ].

nameDetector := FastDetector new.
nameDetector collection: col.
nameDetector keyGenerator: [:value| value name ].

col add: item.

idDetector updateDictionary.
nameDetector updateDictionary.

self assert: (idDetector at:  'AB') == item.
self assert: (nameDetector at: 'Darin') == item.! !

TestCase subclass: #MultiFastDetectorTest
	instanceVariableNames: 'm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastDetector'!

!MultiFastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:50'!
setUp
	super setUp.
	m := MultiFastDetector new.! !

!MultiFastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:50'!
testAreDetectorsSharingCollectionCorrectly
self assert: m areDetectorsSharingCollectionCorrectly.

m collection: OrderedCollection new.
self assert: m areDetectorsSharingCollectionCorrectly.

m detectorAt: #id.
self assert: m areDetectorsSharingCollectionCorrectly.

m add: (MFDTestDummyItem new name: 'Darin'; id: 'AB').
self assert: m areDetectorsSharingCollectionCorrectly.! !

!MultiFastDetectorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/24/2013 10:50'!
testBasicUse
	| item |
	m collection: OrderedCollection new.
	m detectorAt: #id.
	item := MFDTestDummyItem new
		name: 'Darin';
		id: 'AB'.
	m add: item.
	self assert: (m detect: #id equals: 'AB') == item.
	self assert: (m detect: #name equals: 'Darin') == item! !
